#!/bin/bash

cdir=$(dirname $0)

###### warning ##############################################
# This script will install monitoring agent for ToastCloud. #
# You have to run this script as root authentication.       #
#############################################################

# add sensu repository
cp -f $cdir/sensu.repo /etc/yum.repos.d

# install sensu client and ruby
yum install -y gcc sensu.x86_64 ruby-devel.x86_64 rubygems.noarch
gem install sensu-plugin --no-rdoc --no-ri
gem install zip

# sensu-client is automatically executed when server boot up.
chkconfig sensu-client on

# get instance-uuid from openstack metadata server
metadata=$(curl http://169.254.169.254/openstack/2012-08-10/meta_data.json)
uuid=$(echo $metadata | ./jq '.uuid' | sed -e 's/"//g')
address=$(echo $metadata | ./jq '.hostname' | sed -e 's/"//g')
sed -i "s/#{CLIENT_UUID}/$uuid/g" $cdir/conf.d/client.json
sed -i "s/#{CLIENT_HOSTNAME}/$address/g" $cdir/conf.d/client.json

# configure sensu client
cp -f $cdir/conf.d/* /etc/sensu/conf.d
cp -f $cdir/plugins/* /etc/sensu/plugins
cp -rf $cdir/ssl /etc/sensu

chown -R sensu /etc/sensu
chgrp -R sensu /etc/sensu

# start sensu client
service sensu-client start